stages:
  - test
  - sonar
  - deploy
  - deploy-release

create-test-coverage-report:
  stage: test
  image: python:3-slim
  script:
    - pip3 install -r python/requirements.txt
    - cd python && coverage3 run -m unittest tests/test_*.py && coverage3 xml && cd ..
  artifacts:
    paths:
      - python/coverage.xml
  only:
    - merge_requests
    - main

variables:
  SONAR_USER_HOME: "${CI_PROJECT_DIR}/.sonar"  # Defines the location of the analysis task cache
  GIT_DEPTH: "0"  # Tells git to fetch all the branches of the project, required by the analysis task
test:
  stage: sonar
  image:
    name: sonarsource/sonar-scanner-cli:latest
    entrypoint: [""]
  dependencies:
    - create-test-coverage-report
  cache:
    key: "${CI_JOB_NAME}"
    paths:
      - .sonar/cache
      - ~/.cache/pip/
  script:
    - sonar-scanner
  only:
    - merge_requests
    - main

deploy:
  stage: deploy
  script:
    - echo BUILDNUMBER=${CI_JOB_ID} > build.info
    - echo COMMIT_SHA=${CI_COMMIT_SHORT_SHA} >> build.info
    - date +'TIMESTAMP=%Y%m%d%H%M%S' >> build.info
    - echo SOURCE=${CI_PROJECT_URL}/-/tree/${CI_COMMIT_SHORT_SHA} >> build.info
    - echo BUILD-JOB=${CI_JOB_URL} >> build.info
    - cat build.info
  artifacts:
    paths:
      - build.info
      - python/**
    exclude:
      - python/tests/**
      - python/tests

deploy release:
  stage: deploy-release
  dependencies:
    - deploy
  script:
    - BUILDNUMBER=$(grep "BUILDNUMBER=" build.info | cut -d'=' -f2)
    - 'wget -O import-scripts.zip ${CI_PROJECT_URL}/-/jobs/${BUILDNUMBER}/artifacts/download'
    - 'curl --header "JOB-TOKEN: $CI_JOB_TOKEN" --upload-file import-scripts.zip "${CI_API_V4_URL}/projects/${CI_PROJECT_ID}/packages/generic/import-scripts/${CI_COMMIT_TAG}/import-scripts.zip"'
  only:
    - tags
